import { ObjectProperty } from './utils';
export interface ErrorPath<T = unknown> {
    path: ObjectProperty[];
    message: string;
    payload?: T;
}
export default interface ValidationError extends Error {
    paths?: ErrorPath[];
}
export declare function createValidationPathsFromError(key: ObjectProperty, err: Partial<ValidationError>): ErrorPath[];
export declare function createError(paths: ErrorPath[], message?: string): ValidationError;
